'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.InstallationControllerInstance = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _CoreManager = require('./CoreManager');

var _ParsePromise = require('./ParsePromise');

var _ParsePromise2 = _interopRequireDefault(_ParsePromise);

function _interopRequireDefault(obj) {
  return obj && obj.__esModule ? obj : { default: obj };
}

/**
 * Copyright (c) 2015-present, Parse, LLC.
 * All rights reserved.
 *
 * This source code is licensed under the BSD-style license found in the
 * LICENSE file in the root directory of this source tree. An additional grant
 * of patent rights can be found in the PATENTS file in the same directory.
 *
 * 
 */

var iidCache = null;

function hexOctet() {
  return Math.floor((1 + Math.random()) * 0x10000).toString(16).substring(1);
}

function generateId() {
  return hexOctet() + hexOctet() + '-' + hexOctet() + '-' + hexOctet() + '-' + hexOctet() + '-' + hexOctet() + hexOctet() + hexOctet();
}

var InstallationControllerInstance = exports.InstallationControllerInstance = function () {
  function InstallationControllerInstance(coreManager) {
    (0, _classCallCheck3.default)(this, InstallationControllerInstance);

    this._CoreManager = coreManager;
  }

  (0, _createClass3.default)(InstallationControllerInstance, [{
    key: 'currentInstallationId',
    value: function () {
      var _this = this;

      if (typeof iidCache === 'string') {
        return _ParsePromise2.default.as(iidCache);
      }
      var path = this._CoreManager.getStorageFacade().generatePath('installationId');
      return this._CoreManager.getStorageFacade().getItemAsync(path).then(function (iid) {
        if (!iid) {
          iid = generateId();
          return _this._CoreManager.getStorageFacade().setItemAsync(path, iid).then(function () {
            iidCache = iid;
            return iid;
          });
        }
        iidCache = iid;
        return iid;
      });
    }
  }, {
    key: '_clearCache',
    value: function () {
      iidCache = null;
    }
  }, {
    key: '_setInstallationIdCache',
    value: function (iid) {
      iidCache = iid;
    }
  }]);
  return InstallationControllerInstance;
}();

var InstallationController = new InstallationControllerInstance(_CoreManager.CoreManager);
exports.default = InstallationController;