'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ParseInstance = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _decode = require('./decode');

var _decode2 = _interopRequireDefault(_decode);

var _encode = require('./encode');

var _encode2 = _interopRequireDefault(_encode);

var _CoreManager = require('./CoreManager');

var _InstallationController = require('./InstallationController');

var _ParseOp = require('./ParseOp');

var ParseOp = _interopRequireWildcard(_ParseOp);

var _RESTController = require('./RESTController');

var _Storage = require('./Storage');

function _interopRequireWildcard(obj) {
  if (obj && obj.__esModule) {
    return obj;
  } else {
    var newObj = {};if (obj != null) {
      for (var key in obj) {
        if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key];
      }
    }newObj.default = obj;return newObj;
  }
}

function _interopRequireDefault(obj) {
  return obj && obj.__esModule ? obj : { default: obj };
}

var ParseInstance = exports.ParseInstance = function () {
  /**
   * Call this method first to set up your authentication tokens for Parse.
   * You can get your keys from the Data Browser on parse.com.
   * @param {String} applicationId Your Parse Application ID.
   * @param {String} javaScriptKey (optional) Your Parse JavaScript Key (Not needed for parse-server)
   * @param {String} masterKey (optional) Your Parse Master Key. (Node.js only!)
   * @static
   */
  function ParseInstance(applicationId, javaScriptKey, masterKey, coreManager) {
    (0, _classCallCheck3.default)(this, ParseInstance);

    if (coreManager) this._CoreManager = coreManager;else this._CoreManager = new _CoreManager.CoreManagerInstance();

    this._initialize(applicationId, javaScriptKey, masterKey);
  }

  (0, _createClass3.default)(ParseInstance, [{
    key: '_initialize',

    /**
     * Contains all Parse API classes and functions.
     * @static
     * @global
     * @class
     * @hideconstructor
     */

    value: function (applicationId, javaScriptKey, masterKey) {
      var _this = this;

      this._CoreManager.set('APPLICATION_ID', applicationId);
      this._CoreManager.set('JAVASCRIPT_KEY', javaScriptKey);
      this._CoreManager.set('MASTER_KEY', masterKey);
      this._CoreManager.set('USE_MASTER_KEY', false);

      var ParseObjectFacade = require('./ParseObject').ParseObjectFacade;
      this.Object = new ParseObjectFacade(this._CoreManager);

      var ParseUserFacade = require('./ParseUser').ParseUserFacade;
      this.User = new ParseUserFacade(this._CoreManager);

      var ParseQueryFacade = require('./ParseQuery').ParseQueryFacade;
      this.Query = new ParseQueryFacade(this._CoreManager);

      var StorageFacade = require('./Storage').StorageFacade;
      this.Storage = new StorageFacade(this._CoreManager);

      var PushFacade = require('./Push').PushFacade;
      this.Push = new PushFacade(this._CoreManager);

      var ParseTasksFacade = require('./ParseTasks').ParseTasksFacade;
      this.Tasks = new ParseTasksFacade(this._CoreManager);

      require('./ParseHooks').ParseHooksFacade;

      this.Hooks = new ParseTasksFacade(this._CoreManager);

      var ParseSessionFacade = require('./ParseSession').ParseSessionFacade;
      this.Session = new ParseSessionFacade(this._CoreManager);

      this.Relation = require('./ParseRelation').default;
      this.ACL = require('./ParseACL').default;

      this.Role = require('./ParseRole').makeParseRole(this._CoreManager);
      this.Installation = require('./ParseInstallation').makeParseInstallation(this._CoreManager);

      this.File = require('./ParseFile').makeParseFile(this._CoreManager);

      var ParseCloudFacade = require('./Cloud').default;
      this.Cloud = new ParseCloudFacade(this._CoreManager);

      var ParseAnalyticsFacade = require('./Analytics').ParseAnalyticsFacade;
      this.Analytics = new ParseAnalyticsFacade(this._CoreManager);

      var ParseConfigFacade = require('./ParseConfig').ParseConfigFacade;
      this.Config = new ParseConfigFacade(this._CoreManager);

      this.Error = require('./ParseError').default;
      this.GeoPoint = require('./ParseGeoPoint').default;
      this.Polygon = require('./ParsePolygon').default;

      var FacebookUtilsFacade = require('./FacebookUtils').FacebookUtilsFacade;
      this.FacebookUtils = new FacebookUtilsFacade(this._CoreManager);

      this.Op = {
        Set: ParseOp.SetOp,
        Unset: ParseOp.UnsetOp,
        Increment: ParseOp.IncrementOp,
        Add: ParseOp.AddOp,
        Remove: ParseOp.RemoveOp,
        AddUnique: ParseOp.AddUniqueOp,
        Relation: ParseOp.RelationOp
      };
      this.Promise = require('./ParsePromise').default;

      var ParseSchemaFacade = require('./ParseSchema').ParseSchemaFacade;
      this.Schema = new ParseSchemaFacade(this._CoreManager);

      var LiveQueryFacade = require('./ParseLiveQuery').LiveQueryFacade;
      this.LiveQuery = new LiveQueryFacade(this._CoreManager);
      this.LiveQueryClient = require('./LiveQueryClient').default;

      this._CoreManager.setInstallationController(new _InstallationController.InstallationControllerInstance(this._CoreManager));

      //Setting Datonis object
      var DatonisFacade = require('./Datonis').default;
      this.Datonis = new DatonisFacade("test", 5, this._CoreManager);
      this.RESTController = new _RESTController.RESTControllerFacade(this._CoreManager);

      this._request = function () {
        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
          args[_key] = arguments[_key];
        }

        return _this._CoreManager.getRESTController().request.apply(_this._CoreManager.getRESTController(), args);
      };
      this._ajax = function () {
        for (var _len2 = arguments.length, args = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
          args[_key2] = arguments[_key2];
        }

        return _this._CoreManager.getRESTController().ajax.apply(_this._CoreManager.getRESTController(), args);
      };
      // We attempt to match the signatures of the legacy versions of these methods
      this._decode = function (_, value) {
        return (0, _decode2.default)(value, _this._CoreManager);
      };
      this._encode = function (value, _, disallowObjects) {
        return (0, _encode2.default)(value, disallowObjects);
      };
      this._getInstallationId = function () {
        return _this._CoreManager.getInstallationController().currentInstallationId();
      };

      this.initialize = this._initialize;
      this.Cloud = this.Cloud || {};
      this.Cloud.useMasterKey = function () {
        return _this._CoreManager.set('USE_MASTER_KEY', true);
      };
    }

    /**
     * Call this method to set your AsyncStorage engine
     * Starting Parse@1.11, the ParseSDK do not provide a React AsyncStorage as the ReactNative module
     * is not provided at a stable path and changes over versions.
     * @param {AsyncStorage} storage a react native async storage.
     * @static
     */

  }, {
    key: 'setAsyncStorage',
    value: function (storage) {
      this._CoreManager.setAsyncStorage(storage);
    }

    /** These legacy setters may eventually be deprecated **/
    /** 
     * @member Parse.applicationId
     * @type string
     */

  }, {
    key: 'CoreManager',
    get: function () {
      return this._CoreManager;
    }
  }, {
    key: 'applicationId',
    get: function () {
      return this._CoreManager.get('APPLICATION_ID');
    },
    set: function (value) {
      this._CoreManager.set('APPLICATION_ID', value);
    }

    /** 
     * @member Parse.javaScriptKey
     * @type string
     */

  }, {
    key: 'javaScriptKey',
    get: function () {
      return this._CoreManager.get('JAVASCRIPT_KEY');
    },
    set: function (value) {
      this._CoreManager.set('JAVASCRIPT_KEY', value);
    }

    /** 
     * @member Parse.masterKey
     * @type string
     */

  }, {
    key: 'masterKey',
    get: function () {
      return this._CoreManager.get('MASTER_KEY');
    },
    set: function (value) {
      this._CoreManager.set('MASTER_KEY', value);
    }

    /** 
     * @member Parse.serverURL
     * @type string
     */

  }, {
    key: 'serverURL',
    get: function () {
      return this._CoreManager.get('SERVER_URL');
    },
    set: function (value) {
      this._CoreManager.set('SERVER_URL', value);
    }

    /** 
     * @member Parse.liveQueryServerURL
     * @type string
     */

  }, {
    key: 'liveQueryServerURL',
    get: function () {
      return this._CoreManager.get('LIVEQUERY_SERVER_URL');
    },
    set: function (value) {
      this._CoreManager.set('LIVEQUERY_SERVER_URL', value);
    }

    /**
     * @member Parse.datonisURL
     * @type string
     */

  }, {
    key: 'datonisURL',
    get: function () {
      return this._CoreManager.get('DATONIS_URL');
    },
    set: function (value) {
      this._CoreManager.set('DATONIS_URL', value);
    }
  }]);
  return ParseInstance;
}();
/* End setters */

/**
 * Copyright (c) 2015-present, Parse, LLC.
 * All rights reserved.
 *
 * This source code is licensed under the BSD-style license found in the
 * LICENSE file in the root directory of this source tree. An additional grant
 * of patent rights can be found in the PATENTS file in the same directory.
 */

exports.default = ParseInstance;